header                             
{
package mvcase.persistence.mdlparser;
}

{
import java.awt.*;
import java.io.*;
import java.util.*;
import mvcase.dialogs.ProgressDialog;
import mvcase.persistence.MDLReader;
import mvcase.models.Project;
import mvcase.main.Consts;
}

class MDLParser extends Parser;
options {
   exportVocab=MDL;
   k = 3;
}
{
   public static MDLReader mr;

   public static void parseFile(InputStream s, MDLReader reader, ProgressDialog pd) throws TokenStreamException, RecognitionException
   {
      mr = reader;
      MDLLexer lexer = new MDLLexer(new DataInputStream(s),pd);
      MDLParser parser = new MDLParser(lexer);
      parser.mdl();
   }

   public static Project getProject()
   {
      return mr.getProject();
   }
}

mdl: petal  design
	     ;

petal         : T_LPAR "object"
                "Petal" version
                (written)? (charSet)? T_RPAR
		  ;
version       : "version" Number ;
written       : "_written" STRI;
charSet       : "charSet"  Number;

design        :  T_LPAR "object" "Design" STRI designAttributes T_RPAR
		  ;
designAttributes  :  is_unit  is_loaded (file_name)? (attributes)? (quid)? defaults   
           root_usecase_package  root_category root_subsystem  
           process_structure  properties 
		   ;
is_unit        :  "is_unit"   nboolean
		   ;
is_loaded      :  "is_loaded"  nboolean
		   ;
file_name      :  "file_name"   STRI
		   ;
quid returns [ String ret ] { ret = new String(); }
     : "quid"
       token:STRI
       { ret = token.getText();  }
     ;

defaults    : "defaults"  defaultsAttributes
		   ;

defaultsAttributes :   rightMargin   leftMargin   topMargin  
            bottomMargin   pageOverlap  
           clipIconLabels   autoResize   snapToGrid   gridX 
            gridY   defaultFont   showMessageNum  
           showClassOfObject   notation 
         |  defaultsObject
		   ;
defaultsObject    : T_LPAR "object"  "defaults"  defaultsAttributes T_RPAR
		   ;
rightMargin   : "rightMargin"  Number;

leftMargin    : "leftMargin"  Number;

topMargin     : "topMargin"  Number;

bottomMargin     : "bottomMargin"  Number;

pageOverlap   : "pageOverlap"  Number;

clipIconLabels   : "clipIconLabels"  nboolean;

autoResize    : "autoResize"  nboolean;

snapToGrid    : "snapToGrid"  nboolean;

gridX      : "gridX"  Number;

gridY      : "gridY"  Number;

defaultFont   : "defaultFont"  objectFont
		  ;
objectFont    : T_LPAR "object"  "Font"  attributesFonte T_RPAR
		  ;
attributesFonte   : (size)?
                    (face)?
                    (bold)?
                    (italics)?
                    (underline)?
                    (strike)?
                    (color)?
                    (default_Color)?
                  ;
showMessageNum   : "showMessageNum"  Number;

showClassOfObject : "showClassOfObject"  nboolean;

notation   : "notation"  STRI
		  ;

size    : "size"   Number;

face    : "face"  STRI;

bold    : "bold"  nboolean;

italics    : "italics"  nboolean;

underline : "underline"  nboolean;

strike     : "strike"  nboolean;

color   : "color"  Number;

default_Color : "default_color"   nboolean;

root_usecase_package : "root_usecase_package"
                       class_category_RootUseCase
                     ;
class_category_RootUseCase : { mr.startUseCaseModel(); }
                             class_Category_general
                             (logical_Models_RootUseCase)?
                             (logical_Presentations_RootUseCase)?
                             T_RPAR
                             { mr.endModel(); }
	                   ;
class_Category_general : { String sname = null;
                           String squid = null;
                           String sdoc = null;
                           String sstereo = null;
                           boolean bglobal = false;
                           String squidu = null; }
                         T_LPAR "object"  "Class_Category"
                         token:STRI { sname = token.getText(); }
                         (is_unit)?
                         (is_loaded)?
                         (file_name)?
                         (attributes)?
                         squid = quid
                         { mr.setModelQuid(squid); }
                         (sdoc = documentation)?
                         (sstereo = stereotype)?
                         (visible_categories)?
                         (realized_interfaces)?
                         (exportControl)?
                         (bglobal = global)?
                         (subsystem)?
                         (squidu = quidu)?
                         { mr.setModelProperties(sname,
                                                 sdoc,
                                                 sstereo,
                                                 bglobal,
                                                 squidu); }
                       ;
root_category  : "root_category"
                 class_category_RootCategory
		;
class_category_RootCategory : { mr.startLogicalModel(); }
                              class_Category_general
                              ( (logical_Models_RootCategory)?
                                (logical_Presentations_RootCategory)? |
                                is_unit is_loaded file_name
                              )
                              T_RPAR
                              { mr.endModel(); }
                            ;
root_subsystem : "root_subsystem"
                 subsystem_Object
               ;
subsystem_Object : { String sname = null;
                     String squid = null;
                     String sstereo = null;
                     Vector externaldocs = null; }
                   { mr.startComponentModel(); }
                   T_LPAR "object" "SubSystem"
                   token:STRI { sname = token.getText(); }
                   (is_unit)?
                   (is_loaded)?
                   (file_name)?
                   squid = quid
                   (sstereo = stereotype)?
                   { mr.setModelQuid(squid); }
                   (externaldocs = external_docs)?
                   (visible_modules)?
                   (physical_Models)?
                   (physical_Presentations)?
                   T_RPAR
                   { mr.setModelProperties(sname,sstereo); }
                   { mr.endModel(); }
                 ;
process_structure : "process_structure"
                    processes_obj
                  ;
properties    : "properties"  propertiesAttribute 
		  ;
propertiesAttribute  : T_LPAR "object"  "Properties"  propertiesAttribute T_RPAR
           | attributes  quid
		 ;
processes_obj : { String squid = null; }
                { mr.startDeploymentModel(); }
                T_LPAR "object"  "Processes"
                squid = quid
                { mr.setModelQuid(squid); }
                (procsNDevs)?
                T_RPAR
                { mr.endModel(); }
              ;
procsNDevs   : "ProcsNDevs"  T_LPAR "list"  (list_Procs)* T_RPAR 
		 ;
list_Procs	 : process_diagram 
		 | processor
       | device
		 ;

processor : { String squid = null;
              String sdoc = null;
              String sstereo = null; }
            T_LPAR "object" "Processor"
            token:STRI
            squid = quid
            (sdoc = documentation)?
            (sstereo = stereotype)?
            { mr.startProcessor(token.getText(),squid,sdoc,sstereo); }
            (connections)?
            characteristics
            scheduling
            processes
            T_RPAR
            { mr.endProcessor(); }
		 ;
device : { String squid = null;
           String sdoc = null;
           String sstereo = null; }
         T_LPAR "object" "Device"
         token:STRI
         squid = quid
         (sdoc = documentation)?
         (sstereo = stereotype)?
         { mr.startDevice(token.getText(),squid,sdoc,sstereo); }
         (connections)?
         characteristics
         T_RPAR
         { mr.endDevice(); }
		 ;
processes    : "processes"  processes_list
		 ;
processes_list  : T_LPAR "list"  "processes"  (processes_obj)* T_RPAR
		 ;
characteristics  : "characteristics"  STRI
		 ;
scheduling : "scheduling"  STRI
	   ;
connections  : "connections"  connections_list
		 ;
connections_list : T_LPAR "list"  "connection_list"  (connection_relationship)+ T_RPAR
		 ;
connection_relationship : T_LPAR "object" "Connection_Relationship"
                          { String squid = null;
                            String sdoc = null;
                            String sstereo = null;
                            String slabel = null;
                            String squidu = null; }
                          squid = quid
                          (sdoc = documentation)?
                          (sstereo = stereotype)?
                          (slabel = label)?
                          supplier2
                          squidu = quidu
                          supplier_is_device
                          T_RPAR
                          { mr.addConnection(squid,
                                             sdoc,
                                             sstereo,
                                             slabel,
                                             squidu); }
                        ;
supplier_is_device      : "supplier_is_device"  nboolean
		        ;

processorView : T_LPAR "object" "ProcessorView"
                { int iref = 0;
                  Point plocation = null;
                  String squidu = null;
                  String slinecolor = null;
                  String sfillcolor = null;
                  int iwidth = 0;
                  int iheight = 0; }
                STRI
                T_ARROBA token:Number { iref = Integer.parseInt(token.getText()); }
                plocation = location
                (font)?
                (grlabel)?
                (grstereotype)?
                icon_style
                (slinecolor = line_color)?
                (sfillcolor = fill_color)?
                squidu = quidu
                (iwidth = width)?
                (iheight = height)?
                annotation
                T_RPAR
                { mr.addProcessorView(iref,
                                      plocation,
                                      squidu,
                                      slinecolor,
                                      sfillcolor,
                                      iwidth,
                                      iheight); }
              ;
deviceView : T_LPAR "object" "DeviceView"
             { int iref = 0;
               Point plocation = null;
               String squidu = null;
               String slinecolor = null;
               String sfillcolor = null;
               int iwidth = 0;
               int iheight = 0; }
             STRI
             T_ARROBA token:Number { iref = Integer.parseInt(token.getText()); }
             plocation = location
             (font)?
             (grlabel)?
             icon_style
             (slinecolor = line_color)?
             (sfillcolor = fill_color)?
             squidu = quidu
             (iwidth = width)?
             (iheight = height)?
             annotation
             T_RPAR
             { mr.addDeviceView(iref,
                                plocation,
                                squidu,
                                slinecolor,
                                sfillcolor,
                                iwidth,
                                iheight); }
              ;
process_diagram : T_LPAR "object" "Process_Diagram"  
                  { String sname = null;
                    String squid = null;
                    String sdoc = null; }
                  sname = viewType
                  squid = quid
                  title
                  (sdoc = documentation)?
                  { mr.startProcessDiagram(sname,squid,sdoc); }
                  zoom
                  max_height
                  max_width
                  origin_X
                  origin_Y
                  items_PrDiag
                  T_RPAR
                  { mr.endProcessDiagram(); }
                ;

items_PrDiag:"items"  diagram_item_list_PrDiag
	      ;

diagram_item_list_PrDiag : T_LPAR "list"  "diagram_item_list"  (item_list_PrDiag)*T_RPAR
		  ;
item_list_PrDiag: subSysView
	    | modVisView
	    | processorView
       | deviceView
	    | connectionView
	    | label_Object
	    | noteView
	    | attachView
	    ;
attachView : T_LPAR "object" "AttachView"
             { Hashtable hproperties = null; }
             hproperties = attrView
             T_RPAR
             { mr.addAttachView(hproperties); }
	      ;
connectionView : T_LPAR "object" "ConnectionView"
                 { Hashtable hproperties = null; }
                 hproperties = attrView
                 T_RPAR
                 { mr.addConnectionView(hproperties); }
               ;
physical_Presentations: "physical_presentations"  unit_reference_list_PP
		      ;
unit_reference_list_PP  :T_LPAR "list"  "unit_reference_list"  
         (objectOrSetUnitReference_PP)* T_RPAR
	           ;
objectOrSetUnitReference_PP : module_diagram
			    ;
module_diagram  : T_LPAR "object"  "Module_Diagram"
                  { String sname = null;
                    String squid = null;
                    String sdoc = null; }
                  sname = viewType
                  squid = quid
                  title
                  (sdoc = documentation)?
                  { mr.startModuleDiagram(sname,squid,sdoc); }
                  zoom
                  max_height
                  max_width
                  origin_X
                  origin_Y
                  items_ModDiag
                  T_RPAR
                  { mr.endModuleDiagram(); }
                ;
items_ModDiag : "items"  diagram_item_list_ModDiag
	      ;

diagram_item_list_ModDiag : T_LPAR "list"  "diagram_item_list"  (item_list_ModDiag)* T_RPAR
		  ;
item_list_ModDiag: subSysView
	    | modVisView
	    | modView
	    | interfaceView
       | realizeView
       | noteView
       | attachView
	    ;

interfaceView : T_LPAR "object" "InterfaceView"
                { String sname = null;
                  int iref = -1;
                  Point plocation = null;
                  String slinecolor = null;
                  String sfillcolor = null;
                  String squidu = null;
                  int iwidth = 0;
                  int iheight = 0; }
                token:STRI { sname = token.getText(); }
                T_ARROBA token2:Number { iref = Integer.parseInt(token2.getText()); }
                plocation = location
                (font)?
                (grlabel)?
                (grstereotype)?
                (icon)?
                (icon_style)?
                (slinecolor = line_color)?
                (sfillcolor = fill_color)?
                squidu = quidu
                (iwidth = width)?
                (iheight = height)?
                autoResize
                T_RPAR
                { mr.addInterfaceView(sname,
                                      iref,
                                      plocation,
                                      slinecolor,
                                      sfillcolor,
                                      squidu,
                                      iwidth,
                                      iheight); }
              ;

modView : T_LPAR "object" "ModView"
          { int iref = -1;
            Point plocation = null;
            String slinecolor = null;
            String sfillcolor = null;
            String squidu = null;
            int iwidth = 0;
            int iheight = 0; }
          viewType
          viewType viewType
          T_ARROBA token:Number { iref = Integer.parseInt(token.getText()); }
          plocation = location
          (font)?
          (grlabel)?
          (grstereotype)?
          (icon)?
          icon_style
          (slinecolor = line_color)?
          (sfillcolor = fill_color)?
          squidu = quidu
          (iwidth = width)?
          (iheight = height)?
          autoResize
          (iwidth = width)?
          (iheight = height)?
          T_RPAR
          { mr.addModView(iref,
                          plocation,
                          slinecolor,
                          sfillcolor,
                          squidu,
                          iwidth,
                          iheight); }
        ; 
subSysView : T_LPAR "object"  "SubSysView"
             { int iref = -1;
               Point plocation = null;
               String slinecolor = null;
               String sfillcolor = null;
               String squidu = null;
               int iwidth = 0;
               int iheight = 0; }
             STRI
             T_ARROBA token:Number { iref = Integer.parseInt(token.getText()); }
             plocation = location
             (font)?
             (grlabel)?
             (grstereotype)?
             icon_style
             (slinecolor = line_color)?
             (sfillcolor = fill_color)?
             squidu = quidu
             iwidth = width
             iheight = height
             (autoResize)?
             { mr.addSubSysView(iref,
                                plocation,
                                slinecolor,
                                sfillcolor,
                                squidu,
                                iwidth,
                                iheight); }
             T_RPAR
           ;
modVisView : T_LPAR "object" "ModVisView"
             { int iref = -1;
               Hashtable hlabel = null;
               String slinecolor = null;
               String sfillcolor = null;
               String squidu = null;
               int iclient = -1;
               int isupplier = -1;
               Vector vvertices = null; }
             STRI
             T_ARROBA token:Number { iref = Integer.parseInt(token.getText()); }
             (hlabel = grlabel)?
             (grstereotype)?
             (icon_style)?
             (slinecolor = line_color)?
             (sfillcolor = fill_color)?
             squidu = quidu
             iclient = client
             isupplier = supplier
             (vvertices = vertices)?
             line_style
             T_RPAR
             { mr.addModVisView(iref,
                                hlabel,
                                slinecolor,
                                squidu,
                                iclient,
                                isupplier,
                                vvertices); }
           ;
physical_Models    : "physical_models"   unit_reference_list_PM
		 ;
unit_reference_list_PM  :T_LPAR "list"  "unit_reference_list"  
         (objectOrSetUnitReference_PM)* T_RPAR
	           ;
objectOrSetUnitReference_PM : subsystem_Object
                            | module_Object
                            ;
module_Object : T_LPAR "object" "module"
                { String sname = null;
                  String squid = null;
                  String sdoc = null;
                  String sstereo = null;
                  Vector externaldocs = null;
                  String sdeclarations = null; }
                sname = viewType
                viewType viewType
                (attributes)?
                squid = quid
                (sdoc = documentation)?
                (sstereo = stereotype)?
                (externaldocs = external_docs)?
                { mr.startModule(sname,squid,sdoc,sstereo,externaldocs); }
                (visible_modules)?
                (realized_interfaces)?
                (sdeclarations = declarations)?
                (language)?
                T_RPAR
                { mr.endModule(sdeclarations); }
              ;
visible_modules  : "visible_modules"  dependency_list
		 ;
declarations returns [ String ret ] { ret = new String(); }
             : "declarations" token:STRI { ret = token.getText(); }
             ;
dependency_list  : T_LPAR "list"  "dependency_list"
          ( ( dependency_Relationship
            | module_visibility_Relationship ) )* T_RPAR
		 ;
dependency_Relationship : T_LPAR "object" "Dependency_Relationship"
                          { String squid = null;
                            String sdoc = null;
                            String sstereo = null;
                            String slabel = null;
                            String squidu = null; }
                          squid = quid
                          (sdoc = documentation)?
                          (sstereo = stereotype)?
                          (slabel = label)?
                          supplier2
                          squidu = quidu
                          (supplier_is_subsystem)?
                          (supplier_is_spec)?
                          (supplier_is_interface)?
                          T_RPAR
                          { mr.addDependency(squid,sdoc,sstereo,slabel,squidu,"",""); }
                        ;
module_visibility_Relationship : T_LPAR "object" "Module_Visibility_Relationship"
                                 { String squid = null;
                                   String sdoc = null;
                                   String slabel = null;
                                   String squidu = null; }
                                 squid = quid
                                 (sdoc = documentation)?
                                 (slabel = label)?
                                 supplier2
                                 squidu = quidu
                                 (supplier_is_subsystem)?
                                 (supplier_is_spec)?
                                 (supplier_is_interface)?
                                 T_RPAR
                                 { mr.addDependency(squid,sdoc,"",slabel,squidu,"",""); }
                               ;
supplier_is_subsystem : "supplier_is_subsystem"  nboolean
		      ;
supplier_is_interface : "supplier_is_interface"  nboolean
		      ;
supplier_is_spec      : "supplier_is_spec"  nboolean
		      ;

logical_Presentations_RootCategory :"logical_presentations"  unit_reference_list_LPRootCategory
		     ;
unit_reference_list_LPRootCategory: T_LPAR "list"  "unit_reference_list"  
         (objectOrSetUnitReference_LPRootCategory)* T_RPAR
	           ;
objectOrSetUnitReference_LPRootCategory: classDiagram
				       | interactionDiagram
				       | objectDiagram
                   | tierClDiagram
				       ;
tierView : T_LPAR "object" "TierView"
           viewType
           T_ARROBA Number
           (location)?
           (font)?
           (grlabel)?
           (grstereotype)?
           (icon_style)?
           (line_color)?
           (fill_color)?
           (hidden)?
           quidu
           width
           height
           T_RPAR
         ;
tierClDiagram : T_LPAR "object" "Tier_Diagram"
               { String sname = null;
                 String squid = null;
                 String sdoc = null;
                 String sstereo = null; }
               sname = viewType
               squid = quid
               (sstereo = stereotype)?
               title
               (sdoc = documentation)?
               { mr.startClassDiagram(sname,squid,sdoc,sstereo); }
               zoom
               max_height
               max_width
               origin_X
               origin_Y
               items_tierClDiag
               T_RPAR
               { mr.endClassDiagram(); }
             ;
items_tierClDiag :"items"  diagram_item_list_tierClDiag
               ;
diagram_item_list_tierClDiag : T_LPAR "list"  "diagram_item_list"  (item_list_tierClDiag)* T_RPAR
		  ;
item_list_tierClDiag: tierView
       | classView
	    | realizeView
	    | associationViewNew
	    | inheritView
	    | categoryView
	    | label_Object
	    | assocAttachView
	    | usesView
	    | importView 
	    | noteView
       | attachView
	    | inheritTreeView 
	    ;
tierUcDiagram : T_LPAR "object" "Tier_Diagram"
               { String sname = null;
                 String squid = null;
                 String sdoc = null;
                 String sstereo = null; }
               sname = viewType
               squid = quid
               (sstereo = stereotype)?
               title
               (sdoc = documentation)?
               { mr.startClassDiagram(sname,squid,sdoc,sstereo); }
               zoom
               max_height
               max_width
               origin_X
               origin_Y
               items_tierUcDiag
               T_RPAR
               { mr.endClassDiagram(); }
             ;
items_tierUcDiag :"items"  diagram_item_list_tierUcDiag
               ;
diagram_item_list_tierUcDiag : T_LPAR "list"  "diagram_item_list"  (item_list_tierUcDiag)* T_RPAR
		  ;
item_list_tierUcDiag: tierView
                | useCaseView
                | classView
                | associationViewNew
                | inheritView
                | categoryView
                | importView
                | usesView
                | noteView
                | attachView
                | label_Object
                ;

classDiagram : T_LPAR "object" "ClassDiagram"
               { String sname = null;
                 String squid = null;
                 String sdoc = null;
                 String sstereo = null; }
               sname = viewType
               squid = quid
               (sstereo = stereotype)?
               title
               (sdoc = documentation)?
               { mr.startClassDiagram(sname,squid,sdoc,sstereo); }
               zoom
               max_height
               max_width
               origin_X
               origin_Y
               items_clDiag
               T_RPAR
               { mr.endClassDiagram(); }
             ;
items_clDiag:"items"  diagram_item_list_clDiag
	      ;

diagram_item_list_clDiag : T_LPAR "list"  "diagram_item_list"  (item_list_clDiag)*T_RPAR
		  ;
item_list_clDiag: classView
	    | realizeView
	    | associationViewNew
	    | inheritView
	    | categoryView
	    | label_Object
	    | assocAttachView
	    | usesView
	    | importView 
	    | noteView
       | attachView
	    | inheritTreeView 
	    ;

inheritTreeView : T_LPAR "object"  "InheritTreeView"  STRI T_ARROBA Number 
           attributeInh T_RPAR
		;
attributeInh    : location (font)? (stereotype)? (icon_style)? (line_color)? (fill_color)?  
        supplier  vertices
      | stereotype line_color  quidu  client  supplier  line_style  
        origin_attachment  terminal_attachment  drawSupplier
	      ;

assocAttachView : T_LPAR "object" "AssocAttachView"
                  { Hashtable hproperties = null; }
                  hproperties = attrView
                  T_RPAR
                  { mr.addAssocAttachView(hproperties); }
                ;
categoryView: T_LPAR "object" "CategoryView"
              { int iref = 0;
                Point plocation = null;
                String slinecolor = null;
                String sfillcolor = null;
                String squidu = null;
                int iwidth = 0;
                int iheight = 0; }
              viewType
              T_ARROBA token:Number { iref = Integer.parseInt(token.getText()); }
              plocation = location
              (font)?
              (grlabel)?
              (grstereotype)?
              (icon_style)?
              (slinecolor = line_color)?
              (sfillcolor = fill_color)?
              squidu = quidu
              iwidth = width
              iheight = height
              (autoResize)?
              T_RPAR
              { mr.addCategoryView(iref,
                                   plocation,
                                   slinecolor,
                                   sfillcolor,
                                   squidu,
                                   iwidth,
                                   iheight); }
            ;
realizeView : T_LPAR "object" "RealizeView"
              { Hashtable hproperties; }
              hproperties = attrView
              T_RPAR
              { mr.addRealizeView(hproperties); }
            ; 
logical_Models_RootCategory : "logical_models"
                              unit_reference_list_LMRootCategory
                            ;
unit_reference_list_LMRootCategory : T_LPAR "list" "unit_reference_list"  
                                     (objectOrSetUnitReference_LMRootCategory)*
                                     T_RPAR
                                    ;
objectOrSetUnitReference_LMRootCategory : association
                                        | class_Object
                                        | mechanism
                                        | class_category_RootCategory
                                        ;
attributes returns [ Hashtable ret ] { ret = new Hashtable(); }
           : "attributes"
             ret = attribute_set
           ;
attribute_set returns [ Hashtable ret ] { ret = new Hashtable(); }
           : T_LPAR "list"  "Attribute_Set"
             ( { Vector att = new Vector(); }
                 att = attribute
               { if(!att.isEmpty())
                 {
                    String name = (String)att.elementAt(0);
                    String value = (String)att.elementAt(1);
                    ret.put(name,value);
                 }
               }
             )*
             T_RPAR
           ;
attribute returns [ Vector ret ] { ret = new Vector(); }
          : T_LPAR "object"  "Attribute"
            { String sname = null;
              String squidu = null;
              String svalue = null; }
            tool
            sname = name
            svalue = value
            T_RPAR
            { if(sname!=null)
              {
                 ret.addElement(sname);
                 ret.addElement(svalue);
              }
            }
          ;
tool      : "tool"  viewType;

name returns [ String ret ] { ret = new String(); }
     : "name" ret = viewType
     | token:STRI { ret = token.getText(); }
     | token2:ID { ret = token2.getText(); }
     ;
value returns [ String ret ] { ret = new String(); }
      : "value"
        ret = valueType
      ;

valueType returns [ String ret ] { ret = new String(); }
          : ret = viewType
          | attribute_set
          | Number
          | { boolean bool = false; } bool = nboolean { ret = Boolean.toString(bool); }
          | "Text"  (attributesPdl)? 
          | T_LPAR ( ( STRI Number T_RPAR )
                   | ( value T_RPAR ) )
          ;
visible_categories:  "visible_categories"  visibility_relationship_list
		  ;
visibility_relationship_list : T_LPAR "list"  "visibility_relationship_list"  
            (visibility_Relationship)+ T_RPAR
			     ;
visibility_Relationship : T_LPAR "object"  "Visibility_Relationship"
                          { String squid = null;
                            String sdoc = null;
                            String slabel = null;
                            String squidu = null;
                          }
                          (attributes)?
                          squid = quid
                          (sdoc = documentation)?
                          (slabel = label)?
                          supplier2
                          squidu = quidu
                          T_RPAR
                          { mr.addVisibility(squid,
                                             sdoc,
                                             slabel,
                                             squidu); }
                        ;
supplier returns [ int ret ] { ret = 0; }
         : "supplier" T_ARROBA
           token:Number { ret = Integer.parseInt(token.getText()); }
         ;
supplier2 returns [ String ret ] { ret = new String(); }
         : "supplier"
           ret=attributesPdl
         ;
quidu returns [ String ret ] { ret = new String(); }
      : "quidu"
        token:STRI
        { ret = token.getText(); }
      ;
exportControl returns [ String ret ] { ret = new String(); }
              : "exportControl"
                token:STRI { ret = token.getText(); }
              ;
global returns [ boolean ret ] { ret = false; }
       : "global"
         ret=nboolean
		 ;
subsystem    :  "subsystem"  STRI
	   	 ;
logical_Presentations_RootUseCase: "logical_presentations"  unit_reference_list_LPRootUseCase
		     ;
unit_reference_list_LPRootUseCase: T_LPAR "list"  "unit_reference_list"  
         (objectOrSetUnitReference_LPUseCase)* T_RPAR
	           ;
useCaseDiagram  : T_LPAR "object"  "UseCaseDiagram"  
                  { String sname = null;
                    String squid = null;
                    String sstereo = null;
                    String sdoc = null; }
                  sname = viewType
                  squid = quid
                  (sstereo = stereotype)?
                  title
                  (sdoc = documentation)?
                  { mr.startUseCaseDiagram(sname,squid,sdoc,sstereo); }
                  zoom
                  max_height
                  max_width
                  origin_X
                  origin_Y
                  items_UCDiag
                  T_RPAR
                  { mr.endUseCaseDiagram(); }
                ;
items_UCDiag : "items"  diagram_item_list_UCDiag
             ;

diagram_item_list_UCDiag : T_LPAR "list"  "diagram_item_list"  (item_list_UCDiag)*T_RPAR
		  ;
item_list_UCDiag: useCaseView
                | classView
                | associationViewNew
                | inheritView
                | categoryView
                | importView
                | usesView
                | noteView
                | attachView
                | label_Object
                | dependencyView
                ;
importView : T_LPAR "object" "ImportView"
             { Hashtable hproperties = null; }
             hproperties = attrView
             T_RPAR
             { mr.addImportView(hproperties); }
           ;
inheritView : T_LPAR "object" "InheritView"
              STRI
              { int iref = 0;
                Hashtable hlabel = null;
                Hashtable hstereotype = null;
                String slinecolor = null;
                String squidu = null;
                int iclient = 0;
                int isupplier = 0;
                Vector vvertices = null; }
              T_ARROBA token:Number { iref = Integer.parseInt(token.getText()); }
              (font)?
              (hlabel = grlabel)?
              (hstereotype = grstereotype)?
              (icon_style)?
              (slinecolor = line_color)?
              squidu = quidu
              iclient = client
              isupplier = supplier
              (vvertices = vertices)?
              line_style
              (origin_attachment)?
              (terminal_attachment)?
              (drawSupplier)?
              T_RPAR
              { mr.addInheritView(iref,
                                  hlabel,
                                  hstereotype,
                                  slinecolor,
                                  squidu,
                                  iclient,
                                  isupplier,
                                  vvertices); }
            ;
drawSupplier  : "drawSupplier"  T_ARROBA Number
	      ;
associationViewNew : T_LPAR "object" "AssociationViewNew"
                     { int iref = 0;
                       Hashtable hlabel = null;
                       Hashtable hstereotype = null;
                       String slinecolor = null;
                       String squidu = null; }
                     viewType T_ARROBA token:Number { iref = Integer.parseInt(token.getText()); }
                     location
                     (font)?
                     (hlabel = grlabel)?
                     (hstereotype = grstereotype)?
                     (icon_style)?
                     (slinecolor = line_color)?
                     (squidu = quidu)?
                     { mr.startAssociationView(iref,
                                               hlabel,
                                               hstereotype,
                                               slinecolor,
                                               squidu); }
                     roleView_list
                     { mr.endAssociationView(); }
                     T_RPAR
                   ;
roleView_list   : "roleview_list"  roleViews_list
		 ;
roleViews_list  : T_LPAR "list"  "RoleViews"  (roleView)* T_RPAR
		 ;
roleView  : T_LPAR "object" "RoleView"
            { Hashtable hlabel = null;
              int isupplier = 0;
              Vector vvertices = null;
              Hashtable hcard = null; }
            viewType T_ARROBA Number
            parent_view
            location
            (font)?
            (hlabel = grlabel)?
            (grstereotype)?
            (icon_style)?
            (line_color)?
            (quidu)?
            client
            isupplier = supplier
            (vvertices = vertices)?
            line_style
            (origin_attachment)?
            (terminal_attachment)?
            (hcard = grlabel)*
            T_RPAR
            { mr.addRoleView(hlabel,isupplier,vvertices,hcard); }
          ;
origin_attachment : "origin_attachment"  num
		  ;
terminal_attachment : "terminal_attachment"  num
		    ;
logical_Models_RootUseCase : "logical_models"  unit_reference_list_LMRootUseCase
		 ;
unit_reference_list_LMRootUseCase: T_LPAR "list"  "unit_reference_list"  
         (objectOrSetUnitReference_LMRootUseCase)* T_RPAR
	           ;
objectOrSetUnitReference_LMRootUseCase: association
			            | class_Object
				    | useCase
				    | class_category_RootUseCase
				    | mechanism
				    ;
useCase : T_LPAR "object"  "UseCase"
          { String sname = null;
            String squid = null;
            String sdoc = null;
            String sstereo = null;
            Vector externaldocs = null; }
          token:STRI { sname = token.getText(); }
          squid = quid
          (sdoc = documentation)?
          (sstereo = stereotype)?
          { mr.startUseCase(sname,squid,sdoc,sstereo); }
          (visible_modules)?
          (superClasses)?
          (rank)?
          (externaldocs = external_docs)?
          (statemachine)?
          (logical_Models_UseCase)?
          (logical_Presentations_UseCase)?
          { mr.endUseCase(); }
          T_RPAR
        ;
logical_Presentations_UseCase: "logical_presentations"  unit_reference_list_LPUseCase
		     ;
unit_reference_list_LPUseCase: T_LPAR "list"  "unit_reference_list"  
         (objectOrSetUnitReference_LPUseCase)* T_RPAR
	           ;
objectOrSetUnitReference_LPUseCase: interactionDiagram
				  | useCaseDiagram
              | classDiagram
				  | objectDiagram
              | tierUcDiagram
              ;
interactionDiagram : T_LPAR "object" "InteractionDiagram"
                     { String sname = null;
                       int imechanism = -1;
                       String squid = null;
                       String sdoc = null; }
                     sname = viewType
                     imechanism = mechanism_ref
                     squid = quid
                     title
                     (sdoc = documentation)?
                     { mr.startInteractionDiagram(sname,imechanism,squid,sdoc); }
                     zoom
                     max_height
                     max_width
                     (height)?
                     (icon_height)?
                     (icon_width)?
                     (annotation)?
                     (focus_of_control)*
                     (origin_X)?
                     (origin_Y)?
                     (items_interact)?
                     T_RPAR
                     { mr.endInteractionDiagram(); }
                   ;
items_interact:"items"  diagram_item_list_interact
	      ;

diagram_item_list_interact : T_LPAR "list"  "diagram_item_list"  (item_list_interact)*T_RPAR
		  ;
item_list_interact : interObjView_Object
                   | interMessView
                   | noteView
                   | selfMessView
                   | label_Object
                   | attachView
                   ;
selfMessView : T_LPAR "object" "SelfMessView"
               { int iref = -1;
                 Hashtable hlabel = null;
                 String slinecolor = null;
                 int iclient = -1;
                 int isupplier = -1;
                 int ifocussrc = -1;
                 Point porigin = null;
                 int iordinal = -1; }
               STRI
               T_ARROBA token:Number { iref = Integer.parseInt(token.getText()); }
               location
               (font)?
               (hlabel = grlabel)?
               (grstereotype)?
               (icon_style)?
               (slinecolor = line_color)?
               (fill_color)?
               iclient = client
               isupplier = supplier
               ifocussrc = focus_src
               (focus_entry)?
               porigin = origin
               terminus
               iordinal = ordinal
               T_RPAR
               { mr.addSelfMessView(iref,
                                    hlabel,
                                    slinecolor,
                                    iclient,
                                    isupplier,
                                    ifocussrc,
                                    porigin,
                                    iordinal); }
             ;
objectDiagram : T_LPAR "object"  "ObjectDiagram"  STRI  mechanism_ref  
      attributesDiagram T_RPAR
	      ;
attributesDiagram: quid  title  zoom  max_height  max_width  
       origin_X  origin_Y  items_objectDiagram
	       ;
items_objectDiagram    : "items"  diagram_item_list_objectDiagram;

diagram_item_list_objectDiagram : T_LPAR "list"  "diagram_item_list"  (item_list_objectDiagram)*T_RPAR
		  ;
item_list_objectDiagram : objectView
			| linkSelfView
			| messView
			| linkView
			| usesView
         | dataflowView
         | label_Object
         | noteView
	        ;
usesView : T_LPAR "object" "UsesView"
           { Hashtable hproperties = null; }
           hproperties = attrView
           T_RPAR
           { mr.addUsesView(hproperties); }
	      ;
dependencyView : T_LPAR "object" "DependencyView"
                 { Hashtable hproperties = null; }
                 hproperties = attrView
                 T_RPAR
                 { mr.addDependencyView(hproperties); }
               ;
messView      : T_LPAR "object"  "MessView"  STRI T_ARROBA Number  
      (location)? (font)? (grstereotype)? (icon_style)? (line_color)? (grlabel)+
      (dataflowview)?
       object_arc  pctDist  height  orientation  
       dir  origin  terminus T_RPAR
	      ;
dataflowview  : "DataFlowView" T_ARROBA Number
              ;
messview  : "MessView" T_ARROBA Number
              ;
object_arc    : "object_arc"  T_ARROBA Number
	      ;
dataflowView  : T_LPAR "object"  "DataFlowView" STRI T_ARROBA Number
                (grstereotype)? (icon_style)? (grlabel)? (dir)?
                (height)? (messview)? T_RPAR
         ;
linkView      : T_LPAR "object"  "LinkView"  attrView T_RPAR
	      ;
linkSelfView  : T_LPAR "object"  "LinkSelfView"  attrView T_RPAR
	      ;
objectView    : T_LPAR "object"  "ObjectView"  STRI T_ARROBA Number  
       location  (font)?  (grlabel)? (grstereotype)? (icon)? 
       (icon_style)?  (line_color)?  (fill_color)?  
       quidu  (width)?  (height)?
       (annotation)?  (autoResize)? (subobjects)?
      x_offset  y_offset T_RPAR
	      ;
y_offset      : "y_offset"  Number
	      ;
subobjects    : "subobjects"  Number
	      ;
noteView : T_LPAR "object" "NoteView"
           { int iref = 0;
             Point plocation = null;
             Hashtable hlabel = null;
             String slinecolor = null;
             String sfillcolor = null; }
           T_ARROBA token:Number { iref = Integer.parseInt(token.getText()); }
           plocation = location
           (font)?
           (hlabel = grlabel)?
           (grstereotype)?
           (icon_style)?
           (slinecolor = line_color)?
           (sfillcolor = fill_color)?
           width
           height
           T_RPAR
           { mr.addNoteView(iref,plocation,hlabel,slinecolor,sfillcolor); }
         ;
mechanism_ref returns [ int ret ] { ret = -1; }
              : "mechanism_ref"
                T_ARROBA
                token:Number { ret = Integer.parseInt(token.getText()); }
              ;
logical_Models_UseCase : "logical_models"  unit_reference_list_LMUseCase
		       ;
unit_reference_list_LMUseCase: T_LPAR "list"  "unit_reference_list"  
         (objectOrSetUnitReference_LMUseCase)* T_RPAR
	           ;
objectOrSetUnitReference_LMUseCase: mechanism
			        ;
mechanism : T_LPAR "object" "Mechanism"
            T_ARROBA token:Number
            { mr.startMechanism(Integer.parseInt(token.getText())); }
            (logical_Models_mechanism)?
            T_RPAR
            { mr.endModel(); }
          ;
logical_Models_mechanism : "logical_models" unit_reference_list_mechanism
                         ;

unit_reference_list_mechanism: T_LPAR "list"  "unit_reference_list" (object)* T_RPAR
	                     ;
object : T_LPAR "object" "Object"
         { String sname = null;
           String squid = null;
           String sdoc = null;
           String squidu = null;
           String spersistence = null;
           boolean bmulti = false; }
         token:STRI { sname = token.getText(); }
         squid = quid
         (sdoc = documentation)?
         { mr.startObject(sname,squid,sdoc); }
         (collaborators)?
         (classObj)?
         (squidu = quidu)?
         spersistence = persistence
         bmulti = multi
         T_RPAR
         { mr.endObject(squidu,spersistence,bmulti); }
		 ;
persistence returns [ String ret ] { ret = new String(); }
            : "persistence"
              token:STRI { ret = token.getText(); }
            ;
multi returns [ boolean ret ] { ret = false; }
      : "multi" ret = nboolean
      ;
classObj  : "class"  STRI
		 ;
collaborators   : "collaborators"  link_list;

link_list    : T_LPAR "list"  "link_list"  (link)* T_RPAR
		 ;
link : T_LPAR "object" "Link"
       { String squid = null;
         String squidsupplier = null; }
       squid = quid
       (label)?
       (supplier2)?
       (squidsupplier = quidu)?
       { mr.startLink(squid,squidsupplier); }
       (supplier_containment)?
       (client_containment)?
       (supplier_visibility)?
       (client_visibility)?
       (messages)?
       T_RPAR
       { mr.endLink(); }
     ;
supplier_containment : "supplier_containment"  STRI
		     ;
client_containment   : "client_containment"  STRI
		     ;
supplier_visibility : "supplier_visibility"  STRI
		     ;
client_visibility   : "client_visibility"  STRI
		     ;
messages : "messages"  list_messages 
	 ;
list_messages : T_LPAR "list" "Messages"  (message)* T_RPAR
	      ;
message   : T_LPAR "object"  "Message"
            { String sname = null;
              String squid = null;
              String sdoc = null;
              String sfrequency = null;
              String ssynchronization = null;
              String sdir = null;
              String ssequence = null;
              int iordinal = -1;
              String squiduoper = null; }
            token:STRI { sname = token.getText(); }
            squid = quid
            (sdoc = documentation)?
            sfrequency = frequency
            ssynchronization = synchronization
            sdir = dir
            ssequence = sequence
            iordinal = ordinal
            (operationMess)?
            (squiduoper = quidu)?
            T_RPAR
            { mr.addMessage(sname,
                            squid,
                            sdoc,
                            sfrequency,
                            ssynchronization,
                            sdir,
                            ssequence,
                            iordinal,
                            squiduoper); }

          ;
frequency returns [ String ret ] { ret = new String(); }
          : "frequency" ret = viewType
          ;
synchronization returns [ String ret ] { ret = new String(); }
          : "synchronization" ret = viewType
		 ;
dir returns [ String ret ] { ret = new String(); }
    : "dir"
      ret = attributeDir
    ;
attributeDir returns [ String ret ] { ret = new String(); }
             : ret = viewType
             | (T_HIFEN)? Number
             ;
sequence returns [ String ret ] { ret = new String(); }
         : "sequence"
            token:STRI { ret = token.getText(); }
         ;
operationMess   : "Operation"  STRI;
association : T_LPAR "object"  "Association"
              { String sname = null;
                String squid = null;
                String sdoc = null;
                String sstereo = null;
                String sassociationclass = null; }
              sname = viewType  
              { mr.startAssociation(sname); }
              (attributes)?
              squid = quid
              (sdoc = documentation)?
              (sstereo = stereotype)?
              roles
              (sassociationclass = associationClass)?
              (derived)?
              T_RPAR
              { mr.setAssociationProperties(squid,
                                            sdoc,
                                            sstereo,
                                            sassociationclass); }
              { mr.endAssociation(); }
            ;
rank      : "rank"  STRI
	    ;
external_docs returns [ Vector ret ] { ret = new Vector(); }
         : "external_docs" ret = external_doc_list
		   ;
external_doc_list returns [ Vector ret ] { ret = new Vector(); }
            : T_LPAR "list"  "external_doc_list" (
               { String extdoc; }
               extdoc = external_doc
               { ret.add(extdoc); })* T_RPAR
		   ;
external_doc returns [ String ret ] { ret = new String(); }
            : T_LPAR "object" "external_doc" ret = external_doc_path T_RPAR
		   ;
external_doc_path returns [ String ret ] { ret = new String(); } :
                   "external_doc_path" token:STRI { ret = Consts.removeSlashes(token.getText()); }
		   ;
documentation returns [ String ret ] { ret = new String(); }
              : "documentation"
                ret=attributesPdl
              ;
stereotype returns [ String ret ] { ret = new String(); }
           : "stereotype"
             ret=attributeStereotype
           ;
attributeStereotype returns [ String ret ] { ret = null; }
                    : token:STRI { ret = token.getText(); }
                    | nboolean { ret = ""; }
                    ;

grstereotype returns [ Hashtable ret ] { ret = new Hashtable(); }
             : "stereotype" ( ret = itemLabel
                            | ret = segLabel
                            | nboolean
                            )
             ;
itemLabel returns [ Hashtable ret ] { ret = new Hashtable(); }
          : T_LPAR "object" "ItemLabel"  parent_view
            { Point plocation = null;
              String slabel = null; }
            plocation = location
            (grstereotype)?
            (icon_style)?
            (fill_color)?
            (anchor)?
            (anchor_loc)?
            nlines
            max_width
            (justify)?
            slabel = label
            (width)?
            (height)?
            T_RPAR
            { if(plocation!=null)
                 ret.put("location",plocation);
              if(slabel!=null)
                 ret.put("label",slabel);
            }
          ;
parent_view    : "Parent_View"  T_ARROBA Number
		   ;
location returns [ Point ret ] { ret = new Point(); }
         : "location"
           ret = num
		   ;
num returns [ Point ret ] { ret = new Point(); }
         :  T_LPAR
            { int signal1 = 1;
              int signal2 = 1; }
            (T_HIFEN { signal1 = -1; })?
            token1:Number
            T_COMMA
            (T_HIFEN { signal2 = -1; })?
            token2:Number
            T_RPAR
            {  int px = signal1 * ((new Integer(token1.getText())).intValue());
               int py = signal2 * ((new Integer(token2.getText())).intValue());
               ret = new Point(px,py); }
		   ;
fill_color returns [ String ret ] { ret = new String(); }
           : "fill_color"
             token:Number { ret = token.getText(); }
           ;
anchor         : "anchor"  Number
		   ;
anchor_loc     : "anchor_loc"  Number
		   ;
nlines         : "nlines"  Number
		   ;
max_width      : "max_width"  Number
		   ;
justify        : "justify"  Number
		   ;
label returns [ String ret ] { ret = new String(); }
      : 
      "label" ( (token:STRI { ret = token.getText(); })?
                | ( { String line = new String(); }
                    line = body
                    { ret += line; }
                  )+
                )
      ;
grlabel returns [ Hashtable ret ] { ret = new Hashtable(); }
        : "label" ( ret = segLabel
                  | ret = itemLabel
                  )
        ;
segLabel returns [ Hashtable ret ] { ret = new Hashtable(); }
         : T_LPAR "object" "SegLabel" T_ARROBA Number
           { Point plocation = null;
             String squidu = null;
             String slabel = null; }
           parent_view
           plocation = location
           (font)?
           (grstereotype)?
           (icon_style)?
           (squidu = quidu)?
           (hidden)?
           (anchor)?
           anchor_loc
           nlines
           max_width
           (justify)?
           (slabel = label)*
           pctDist
           (height)?
           orientation
           T_RPAR
           { if(plocation!=null)
                ret.put("location",plocation);
             if(squidu!=null)
                ret.put("quidu",squidu);
             if(slabel!=null)
                ret.put("label",slabel);
           }
         ;
label_Object       : T_LPAR "object"  "Label"  (labelAttributes)? T_RPAR
			 ;

labelAttributes		 : mens
          | T_ARROBA Number  (location)?  (font)? (stereotype)? (icon_style)? nlines  max_width  label
			 ;
mens         : STRI T_LPAR STRI T_RPAR 
			 ;

font         : "font"  objectFont
			 ;
hidden        : "hidden"  nboolean
		  ;
pctDist      : "pctDist"  (T_HIFEN)? Number
		 ;
height returns [ int ret ] { ret = 0; }
       : "height" { int signal = 1; }
         (T_HIFEN { signal = -1; })?
         token:Number
         { ret = signal * (new Integer(token.getText())).intValue(); }
		 ;
orientation  : "orientation"  Number
		 ;
roles : "roles" role_list
      ;
role_list : T_LPAR "list" "role_list" (role)* T_RPAR
       ;                             
role : T_LPAR "object"  "Role"
       { String sname = null;
         String squid = null;
         String sdoc = null;
         String squidu = null;
         String scardinality = null;
         String scontainment = null;
         String sexportcontrol = null;
         boolean bisnavigable = false;
         boolean bisaggregate = false; }
       token:STRI { sname = token.getText(); }
       (attributes)?
       squid = quid
       (sdoc = documentation)?
       (label)?
       supplier2
       squidu = quidu
       (keys)?
       (scardinality = client_cardinality)?
       (constraints)?
       (scontainment = containment)?
       (sexportcontrol = exportControl)?
       (bisnavigable = is_navigable)?
       (bisaggregate = is_aggregate)?
       (is_principal)?
       (nstatic)?
       T_RPAR
       { mr.addAssociationRole(sname,
                               squid,
                               sdoc,
                               squidu,
                               scardinality,
                               scontainment,
                               sexportcontrol,
                               bisnavigable,
                               bisaggregate); }
     ;
keys  : "keys" class_attribute_list
      ;
client_cardinality returns [ String ret ] { ret = new String(); }
                   : "client_cardinality"
                     ret = attributeCard
                   ;
supplier_cardinality returns [ String ret ] { ret = new String(); }
                     : "supplier_cardinality"
                       ret = attributeCard
                     ;
attributeCard returns [ String ret ] { ret = new String(); }
              : T_LPAR "value" "cardinality"
                token:STRI { ret = token.getText(); }
                T_RPAR
              ;
constraints   : "Constraints"  STRI
	      ;
containment returns [ String ret ] { ret = new String(); }
            : "Containment"
              token:STRI { ret = token.getText(); }
            ;
is_navigable returns [ boolean ret ] { ret = false; }
             : "is_navigable"
               ret = nboolean
             ;
is_aggregate returns [ boolean ret ] { ret = false; }
             : "is_aggregate"
               ret = nboolean
             ; 
is_principal  : "is_principal"  nboolean
	      ;
nstatic returns [ boolean ret ] { ret = false; }
        : "static"
          ret = nboolean
        ; 
associationClass returns [ String ret ] { ret = new String(); }
                 : "AssociationClass"
                   token:STRI { ret = token.getText(); }
                 ;
derived      : "derived"  nboolean
	    ;
class_Object : T_LPAR "object"  "Class"
               token:STRI
               { mr.startClass(token.getText()); }
               classAttributes
               { mr.endClass(); }
               T_RPAR
             | T_LPAR "object"  "Class_Utility"
               token2:STRI
               { mr.startClass(token2.getText()); }
               classAttributes
               { mr.endClass(); }
               T_RPAR
             | T_LPAR "object"  "Instantiated_Class"
               token3:STRI
               { mr.startClass(token3.getText()); }
               { String squid = null; }
               squid = quid
               { mr.setClassQuid(squid); }
               { mr.endClass(); }
               T_RPAR
	     ;
classAttributes   : { String squid = null;
                      String sdoc = null;
                      String sstereo = null;
                      String sexportcontrol = null;
                      boolean babstract = false;
                      String spersistence = null;
                      Hashtable attrs = new Hashtable(); }
                    (attrs = attributes)?
                    squid = quid
                    { mr.setClassQuid(squid); }
                    (sdoc = documentation)?
                    (sstereo = stereotype)?
                    (superClasses)?
                    (used_nodes)?
                    (type)?
                    (realized_interfaces)?
                    (sexportcontrol = exportControl)?
                    (operation)?
                    (class_attributes)?
                    (statemachine)?
                    ( { String squidu = null; }
                      module
                      squidu=quidu
                      { mr.addModuleToClass(squidu); }
                    )*
                    (language)?
                    (babstract = nabstract)?
                    (spersistence = persistence)?
                    (concurrency)?
                    (nestedClasses)?
                    { mr.setClassProperties(attrs,
                                            sdoc,
                                            sstereo,
                                            sexportcontrol,
                                            babstract,
                                            spersistence); }
                  ;
superClasses    : "superclasses"  (inheritance_relationship_list)*
		 ;
inheritance_relationship_list: T_LPAR "list"  "inheritance_relationship_list"  
                (inheritance_Relationship)* T_RPAR
			 ;
inheritance_Relationship : T_LPAR "object" "Inheritance_Relationship"
                           { String squid = null;
                             String sdoc = null;
                             String sstereo = null;
                             String slabel = null;
                             String ssupplier = null;
                             String squidu = null;
                           }
                           (attributes)?
                           squid = quid
                           (sdoc = documentation)?
                           (sstereo = stereotype)?
                           (slabel = label)?
                           ssupplier = supplier2
                           (squidu = quidu)?
                           T_RPAR
                           { mr.addGeneralization(squid,
                                                  sdoc,
                                                  sstereo,
                                                  slabel,
                                                  ssupplier,
                                                  squidu); }
                         ;
used_nodes: "used_nodes"  uses_relationship_list
	  ;
uses_relationship_list   : T_LPAR "list"  "uses_relationship_list"  (uses_relationship)* T_RPAR
			 ;
uses_relationship : T_LPAR "object"  "Uses_Relationship"
                    { String squid = null;
                      String sdoc = null;
                      String sstereo = null;
                      String slabel = null;
                      String squidu = null;
                      String ssuppliercardinality = null;
                      String sclientcardinality = null;
                    }
                    (attributes)?
                    squid = quid
                    (sdoc = documentation)?
                    (sstereo = stereotype)?
                    (slabel = label)?
                    supplier2
                    squidu = quidu
                    (ssuppliercardinality = supplier_cardinality)?
                    (sclientcardinality = client_cardinality)?
                    T_RPAR
                    { mr.addDependency(squid,
                                       sdoc,
                                       sstereo,
                                       slabel,
                                       squidu,
                                       ssuppliercardinality,
                                       sclientcardinality); }
                  ;
type returns [ String ret ] { ret = new String(); }
     : "type"
       ret = viewType
     ;
viewType returns [ String ret ] { ret = new String(); }
         : token:STRI { ret = token.getText(); }
         ;
realized_interfaces : "realized_interfaces"  realize_rel_list
		    ;
realize_rel_list  : T_LPAR "list"  "realize_rel_list"  (realize_relationship)* T_RPAR
		  ;
realize_relationship : T_LPAR "object" "Realize_Relationship"
                       { String squid = null;
                         String sdoc = null;
                         String sstereo = null;
                         String slabel = null;
                         String ssupplier = null;
                         String squidu = null;
                       }
                       (attributes)?
                       squid = quid
                       (sdoc = documentation)?
                       (sstereo = stereotype)?
                       (slabel = label)?
                       ssupplier = supplier2
                       (squidu = quidu)?
                       T_RPAR
                       { mr.addRealize(squid,
                                       sdoc,
                                       sstereo,
                                       slabel,
                                       ssupplier,
                                       squidu); }
                      ;
operation   : "operations"  operation_list
		;
operation_list : T_LPAR "list"  "Operations"  (operations)* T_RPAR
		;
operations : T_LPAR "object"  "Operation"
             { String sname = null;
               Hashtable attrs = new Hashtable();
               String squid = null;
               String sdoc = null;
               String sstereo = null;
               String sresult = null;
               String sexceptions = null;
               String ssemantics = null;
               String sexportcontrol = null;
               int iuid = 0;
               String squidresult = null; }
             token:STRI { sname = token.getText(); }
             { mr.startOperation(sname); }
             (attrs = attributes)?
             squid = quid
             (sdoc = documentation)?
             (sstereo = stereotype)?
             (parameters)?
             (sresult = result)?
             (sexceptions = exceptions)?
             (concurrency)?
             (pre_condition)?
             (post_condition)?
             (ssemantics = semantics)?
             (sexportcontrol = opExportControl)?
             (iuid = uid)?
             (squidresult = quidu)?
             T_RPAR
             { mr.setOperationProperties(attrs,
                                         squid,
                                         sdoc,
                                         sstereo,
                                         sresult,
                                         sexceptions,
                                         ssemantics,
                                         sexportcontrol,
                                         iuid,
                                         squidresult); }
             { mr.endOperation(); }
           ;
parameters : "parameters"  attributesParam
		;

attributesParam	: parameter_list
		| STRI
		;
parameter_list : T_LPAR "list"  "Parameters"  (parameter)* T_RPAR
		;
parameter : T_LPAR "object" "Parameter"
            { String squid = null;
              String stype = null;
              String squidu = null;
              String sinitv = null; }
            token:STRI
            ( squid = quid )?
            ( stype = type ( squidu = quidu )? ( sinitv = initv )? )?
            T_RPAR
            { mr.addParameter(token.getText(),squid,stype,squidu,sinitv); }
          ;
initv returns [ String ret ] { ret = new String(); }
      : "initv"
         ret = attributesPdl
		;

attributesPdl returns [ String ret ] { ret = new String(); }
              : token:STRI { ret = token.getText(); }
              | ( { String sbody = new String(); }
                  sbody = body
                  { ret += sbody; }
                )+
              ;
body returns [ String ret ] { ret = new String(); }
     : token:STRI2
       { ret = token.getText(); }
     ;
result returns [ String ret ]  { ret = new String(); }
       : "result"
         token:STRI
         { ret = token.getText(); }
       ;
exceptions returns [ String ret ]  { ret = new String(); }
           : "exceptions"
             token:STRI
             { ret = token.getText(); }
           ;
concurrency   : "concurrency"  viewType
	      ;
pre_condition  : "pre_condition"  semantic_info 
		;
post_condition : "post_condition"  semantic_info
		;
semantics returns [ String ret ]  { ret = new String(); }
          : "semantics"
            ret = semantic_info
          ;
semantic_info returns [ String ret ]  { ret = new String(); }
         : T_LPAR "object" "Semantic_Info"
           ret = pdl
           (diagram_ref)?
           T_RPAR
	      ;
pdl returns [ String ret ]  { ret = new String(); }
    : "PDL"
      (ret = attributesPdl)?
    ;
diagram_ref   : "diagram_ref"  STRI
	      ;
opExportControl returns [ String ret ]  { ret = new String(); }
                : "opExportControl"
                  token:STRI
                  { ret = token.getText(); }
                ;
uid returns [ int ret ] { ret = 0; }
    : "uid"
      token:Number
      { try
        {
           Integer i = new Integer(token.getText());
           ret = i.intValue();
        }
        catch(NumberFormatException nfe) {}
      }
    ;
class_attributes : "class_attributes"  class_attribute_list
		 ;

class_attribute_list: T_LPAR "list"  "class_attribute_list"  (classAttribute)+ T_RPAR
		    ;

classAttribute : T_LPAR "object" "ClassAttribute"
                 { Hashtable attrs = new Hashtable();
                   String squid = null;
                   String sdoc = null;
                   String sstereo = null;
                   String stype = null;
                   String squidu = null;
                   String sinitv = null;
                   String sexportcontrol = null;
                   boolean bstatic = false; }
                 token:STRI
                 (attrs = attributes)?
                 squid = quid
                 (sdoc = documentation)?
                 (sstereo = stereotype)?
                 (stype = type)?
                 (squidu = quidu)?
                 (sinitv = initv)?
                 (sexportcontrol = exportControl)?
                 (bstatic = nstatic)?
                 T_RPAR
                 { mr.addAttribute(token.getText(),
                                   attrs,
                                   squid,
                                   sdoc,
                                   sstereo,
                                   stype,
                                   squidu,
                                   sinitv,
                                   sexportcontrol,
                                   bstatic); }
               ;
statemachine    : "statemachine"  state_Machine
		 ;
state_Machine   : { String squid = null; }
                  T_LPAR "object" "State_Machine"
                  token:STRI
                  squid = quid
                  { mr.startStateMachine(token.getText(), squid); }
                  states
                  (partitions)?
                  (objects)?
                  (statediagrams)?
                  { mr.endStateMachine(); }
                  T_RPAR
                ;
partitions   : "partitions"  list_partitions
             ;
list_partitions : T_LPAR "list"  "Partitions" T_RPAR
                ;
objects      : "objects"   list_objects
             ;
list_objects : T_LPAR "list"  "Objects" T_RPAR
             ;
statediagrams : "statediagrams"  list_statediagrams
              ;
list_statediagrams : T_LPAR "list"  "StateDiagrams" (state_diagram)* T_RPAR
                   ;
states       : "states"  list_states
		 ;
list_states  : T_LPAR "list"  "States" (state|syncstate)* T_RPAR
		 ;
state  : { String squid = null;
           String sdoc = null;
           String stype = null; }
         T_LPAR "object" "State"
         token:STRI
         squid = quid
         (sdoc = documentation)?
         { mr.startState(token.getText(),squid,sdoc); }
         (transitions)?
         stype = type
         (actions)?
         (statemachine)?
         { mr.endState(stype); }
         T_RPAR
		 ;
syncstate : { String squid = null;
              String sdoc = null;
              String stype = null; }
            T_LPAR "object" "SynchronizationState"
            token:STRI
            squid = quid
            (sdoc = documentation)?
            { mr.startSyncBar(token.getText(),squid,sdoc); }
            (transitions)?
            (type)?
            (actions)?
            (statemachine)?
            { mr.endSyncBar(); }
            T_RPAR
          ;

transitions  : "transitions"  transition_list
		 ;
transition_list    : T_LPAR "list"  "transition_list"  (state_transition)* T_RPAR
		 ;
state_transition : { String squid = null;
                     String sdoc = null;
                     String sstereo = null;
                     String slabel = null;
                     String squidu = null;
                     String eventquid = null;
                     String sendeventquid = null;
                   }
                   T_LPAR "object" "State_Transition"
                   squid = quid
                   (sdoc = documentation)?
                   (sstereo = stereotype)?
                   (slabel = label)?
                   supplier2
                   squidu = quidu
                   (eventquid = event)?
                   (action_ref)?
                   sendeventquid = sendEvent
                   T_RPAR
                   { mr.addStateTransition(squid,
                                           sdoc,
                                           sstereo,
                                           slabel,
                                           squidu,
                                           eventquid,
                                           sendeventquid); }
                 ;
action_ref  :  "action" action;
event returns [ String ret ] { ret = null; }
      : "Event" ret = attributeObject
            ;
eventObject returns [ String ret ] { ret = null; }
            : T_LPAR "object" ret = event T_RPAR
            ;
sendEvent returns [ String ret ] { ret = null; }
          : "sendEvent" ret = attributeObject
          ;
attributeObject returns [ String ret ] { ret = null; }
                : ret = sendEventObj
                | ret = eventObject
                | actionTimeObj
                | (STRI)? (ret = quid)? (parameters)?
                | when
                ;
when      : "when"  STRI
		 ;
sendEventObj returns [ String ret ] { ret = null; }
             : T_LPAR "object" ret = sendEvent T_RPAR
		 ;
actions      : "actions"  action_list
		 ;
action_list  : T_LPAR "list"  "action_list"  (action)* T_RPAR
		 ;
action       : T_LPAR "object"  "action"  STRI  quid
           (actionTime)? T_RPAR
		 ;
actionTime   : "ActionTime"  attributeObject
		 ;
actionTimeObj   : T_LPAR "object"  actionTime T_RPAR
		 ;
state_diagram  : { String squid = null; }
                 T_LPAR "object" "State_Diagram"
                 token:STRI
                 squid = quid
                 { mr.startStateDiagram(token.getText(),squid); }
                 title
                 zoom
                 max_height
                 max_width  
                 origin_X
                 origin_Y
                 items_state
                 { mr.endStateDiagram(); }
                 T_RPAR
               ;
title        : "title"  viewType
	       ;
zoom         : "zoom"  Number
	       ;
max_height     : "max_height"  Number
	       ;
origin_X       : "origin_x"  Number
	       ;
origin_Y       : "origin_y"  Number
	       ;
items_state    : "items"  diagram_item_list_state;

diagram_item_list_state : T_LPAR "list"  "diagram_item_list"  (item_list_state)* T_RPAR
		  ;
item_list_state : stateView
                | transView
                | selftransView
                | label_Object
                | noteView
                | attachView
                | synchronizationView
                ;
interMessView: T_LPAR "object" "InterMessView"
               { int iref = -1;
                 Hashtable hlabel = null;
                 String slinecolor = null;
                 int iclient = -1;
                 int isupplier = -1;
                 int ifocussrc = -1;
                 int ifocusentry = -1;
                 Point porigin = null;
                 Point pterminus = null;
                 int iordinal = -1; }
               viewType
               T_ARROBA token:Number { iref = Integer.parseInt(token.getText()); }
               location
               (font)?
               (hlabel = grlabel)?
               (grstereotype)?
               (icon_style)?
               (slinecolor = line_color)?
               (fill_color)?
               iclient = client
               isupplier = supplier
               ifocussrc = focus_src
               ifocusentry = focus_entry
               porigin = origin
               pterminus = terminus
               iordinal = ordinal
               T_RPAR
               { mr.addInterMessView(iref,
                                     hlabel,
                                     slinecolor,
                                     iclient,
                                     isupplier,
                                     ifocussrc,
                                     ifocusentry,
                                     porigin,
                                     pterminus,
                                     iordinal); }
             ;
focus_src returns [ int ret ] { ret = -1; }
          : "Focus_Src"
            T_ARROBA token:Number { ret = Integer.parseInt(token.getText()); }
          ;
focus_entry returns [ int ret ] { ret = -1; }
            : "Focus_Entry"
              T_ARROBA token:Number { ret = Integer.parseInt(token.getText()); }
            ;
origin returns [ Point ret ] { ret = new Point(); }
       : "origin"
         ret = num
       ; 
terminus returns [ Point ret ] { ret = new Point(); }
         : "terminus"
           ret = num
         ;
ordinal returns [ int ord ] { ord = -1; }
        : "ordinal"
          token:Number { ord = Integer.parseInt(token.getText()); }
	     ;
classView : T_LPAR "object" "ClassView" STRI
            { int iref = 0;
              boolean bincludeattribute = false;
              boolean bincludeoperation = false;
              Point plocation = null;
              String squidu = null;
              String slinecolor = null;
              String sfillcolor = null;
              int iwidth = 0;
              int iheight = 0; }
            viewType
            T_ARROBA token:Number { iref = Integer.parseInt(token.getText()); }
            (showComp)?
            (suppressAttribute)?
            (suppressOperation)?
            (bincludeattribute = includeAttribute)?
            (bincludeoperation = includeOperation)?
            (showOper)?
            plocation = location
            (font)?
            (grlabel)?
            (grstereotype)?
            (icon)?
            (icon_style)?
            (slinecolor = line_color)?
            (sfillcolor = fill_color)?
            (squidu = quidu)?
            (compartment)?
            (iwidth = width)?
            (iheight = height)?
            (annotation)?
            (autoResize)?
            T_RPAR
            { mr.addClassView(iref,
                              bincludeattribute,
                              bincludeoperation,
                              plocation,
                              squidu,
                              slinecolor,
                              sfillcolor,
                              iwidth,
                              iheight); }
          ;
showOper    : "ShowOperationSignature"  nboolean
		   ;
includeAttribute returns [ boolean ret ] { ret = false; }
                 : "IncludeAttribute"
                   ret = nboolean
                 ;
includeOperation returns [ boolean ret ] { ret = false; }
                 : "IncludeOperation"
                   ret = nboolean
                 ;
showComp       : "ShowCompartmentStereotypes"  nboolean
	     	   ;
suppressAttribute  : "SuppressAttribute"  nboolean   
		   ;
suppressOperation  : "SuppressOperation"  nboolean    
		   ;
useCaseView  : T_LPAR "object" "UseCaseView"
               { int iref = 0;
                 Point plocation = null;
                 String squidu = null;
                 String slinecolor = null;
                 String sfillcolor = null;
                 int iwidth = 0;
                 int iheight = 0; }
               viewType
               T_ARROBA token:Number { iref = Integer.parseInt(token.getText()); }
               plocation = location
               (font)?
               (grlabel)?
               (grstereotype)?
               (icon_style)?
               (slinecolor = line_color)?
               (sfillcolor = fill_color)?
               squidu = quidu
               (iwidth = width)?
               (iheight = height)?
               (autoResize)?
               T_RPAR
               { mr.addUseCaseView(iref,
                                   plocation,
                                   squidu,
                                   slinecolor,
                                   sfillcolor,
                                   iwidth,
                                   iheight); }
             ;

stateView   : T_LPAR "object" "StateView"
              { String stype = null;
                String sname = null;
                int iref = 0;
                Point plocation = null;
                String squidu = null;
                String slinecolor = null;
                String sfillcolor = null;
                int iwidth = 0;
                int iheight = 0; }
              token2:STRI { stype = token2.getText(); }
              sname = viewType
              T_ARROBA token:Number { iref = Integer.parseInt(token.getText()); }
              plocation = location
              (font)?
              (grlabel)?
              (grstereotype)?
              (icon_style)?
              (slinecolor = line_color)?
              (sfillcolor = fill_color)?
              squidu = quidu
              (compartment)?
              (iwidth = width)?
              (iheight = height)?
              autoResize
              T_RPAR
              { mr.addStateView(stype,
                                sname,
                                iref,
                                plocation,
                                squidu,
                                slinecolor,
                                sfillcolor,
                                iwidth,
                                iheight); }
            ;
synchronizationView : { String sname = null;
                        int iref = 0;
                        Point plocation = null;
                        String squidu = null;
                        String slinecolor = null;
                        String sfillcolor = null;
                        int iwidth = 0;
                        int iheight = 0;
                        boolean bhorizontal = false; }
                       T_LPAR "object" "SynchronizationView"
                       token:STRI { sname = token.getText(); }
                       T_ARROBA token2:Number { iref = Integer.parseInt(token2.getText()); }
                       plocation = location
                       (font)?
                       (grlabel)?
                       (grstereotype)?
                       (icon_style)?
                       (slinecolor = line_color)?
                       (sfillcolor = fill_color)?
                       squidu = quidu
                       (compartment)?
                       (iwidth = width)?
                       (iheight = height)?
                       autoResize
                       (sync_flow_direction)?
                       (bhorizontal = sync_is_horizontal)?
                       T_RPAR
                       { mr.addSyncBarView(sname,
                                           iref,
                                           plocation,
                                           squidu,
                                           slinecolor,
                                           sfillcolor,
                                           iwidth,
                                           iheight,
                                           bhorizontal); }
                     ;
sync_flow_direction : "sync_flow_direction" Number
                    ;
sync_is_horizontal returns [ boolean ret ] { ret = false; }
                   : "sync_is_horizontal"
                     ret = nboolean
                   ;

transView : T_LPAR "object" "TransView"
            { Hashtable hproperties = null; }
            hproperties = attrView
            (x_offset)?
            T_RPAR
            { mr.addTransView(hproperties); }
	      ;
selftransView   : T_LPAR "object"  "SelfTransView"  attrView (x_offset)?  T_RPAR
	      ;
interObjView_Object : T_LPAR "object" "InterObjView"
                      { String sname = null;
                        int iref = -1;
                        Point plocation = null;
                        String slinecolor = null;
                        String sfillcolor = null;
                        String squidu = null;
                        int iwidth = 0;
                        int iheight = 0; }
                      sname = viewType
                      T_ARROBA token:Number { iref = Integer.parseInt(token.getText()); }
                      plocation = location
                      (font)?
                      (grlabel)?
                      (grstereotype)?
                      (icon)?
                      (icon_style)?
                      (slinecolor = line_color)?
                      (sfillcolor = fill_color)?
                      squidu = quidu
                      (iwidth = width)?
                      iheight = height
                      icon_height
                      (icon_width)?
                      (icon_y_offset)?
                      (autoResize)?
                      (annotation)?
                      { mr.startInterObjView(sname,
                                             iref,
                                             plocation,
                                             slinecolor,
                                             sfillcolor,
                                             squidu,
                                             iwidth,
                                             iheight); }
                      (focus_of_control)*
                      T_RPAR
                      { mr.endInterObjView(); }
                    ;
focus_of_control : "Focus_Of_Control" T_LPAR "object" "Focus_Of_Control"
                   { int iref = -1;
                     Point plocation = null;
                     int iheight = 0; }
                   viewType
                   T_ARROBA token:Number { iref = Integer.parseInt(token.getText()); }
                   plocation = location
                   (stereotype)?
                   (icon_style)?
                   (line_color)?
                   (fill_color)?
                   interObjView
                   iheight = height
                   y_coord
                   nested
                   T_RPAR
                   { mr.addFocusOfControl(iref,plocation,iheight); }
                 ;
interObjView  : "InterObjView"   T_ARROBA Number
	      ;
annotation    : "annotation"  Number
	      ;
nested        : "Nested"  nboolean
	      ;
y_coord        : "y_coord" (T_HIFEN)? Number
	      ;			   
icon_style    : "icon_style"  STRI
	      ;
icon_width    : "icon_width"  Number
	      ;
icon_y_offset : "icon_y_offset" Number
         ;
icon          : "icon"  STRI
	      ;
icon_height   : "icon_height"  Number
	      ;
line_color returns [ String ret ] { ret = new String(); }
           : "line_color"
             token:Number { ret = token.getText(); }
	      ;
compartment   : "compartment"  compartment_Object
	      ;
compartment_Object  : T_LPAR "object"  "Compartment"  parent_view  
           location  (font)? (stereotype)? (icon_style)?  (fill_color)? 
          anchor  nlines  max_width  (justify)?  (compartmentItems)? T_RPAR
			 ;
compartment_list : T_LPAR "list"  "Compartment"  ((viewType)+|(body)+) T_RPAR
		 ;
compartmentItems : "compartmentItems"  compartment_list
		         ;
width returns [ int ret ] { ret = 0; }
      : "width"
        token:Number { ret = (new Integer(token.getText())).intValue(); }
      ;
attrView returns [ Hashtable ret ] { ret = new Hashtable(); }
         : { int iref = 0;
             Point plocation = null;
             Hashtable hlabel = null;
             Hashtable hstereotype = null;
             String slinecolor = null;
             String squidu = null;
             int iclient = 0;
             int isupplier = 0;
             Vector vvertices = null; }
           STRI T_ARROBA token:Number { iref = Integer.parseInt(token.getText()); }
           (plocation = location)?
           (font)?
           (hlabel = grlabel)?
           (hstereotype = grstereotype)?
           (icon_style)?
           (slinecolor = line_color)?
           (squidu = quidu)?
           iclient = client
           isupplier = supplier
           (vvertices = vertices)?
           line_style
           (origin_attachment)?
           (terminal_attachment)?
           (anchor)?
           { ret.put("ref",new Integer(iref));
             ret.put("client",new Integer(iclient));
             ret.put("supplier",new Integer(isupplier));
             if(plocation!=null)
                ret.put("location",plocation);
             if(hlabel!=null)
                ret.put("label",hlabel);
             if(hstereotype!=null)
                ret.put("stereotype",hstereotype);
             if(slinecolor!=null)
                ret.put("linecolor",slinecolor);
             if(squidu!=null)
                ret.put("quidu",squidu);
             if(vvertices!=null)
                ret.put("vertices",vvertices);
           }
         ;
client returns [ int ret ] { ret = 0; }
       : "client" T_ARROBA
         token:Number
         { ret = Integer.parseInt(token.getText()); }
		 ;
vertices returns [ Vector ret ] { ret = new Vector(); }
         : "vertices"
            ret = points_list
         ;
points_list returns [ Vector ret ] { ret = new Vector(); }
            : T_LPAR "list"  "Points"
              ( { Point p = null; }
                p = num
                { ret.add(p); }
              )*
              T_RPAR
            ;
line_style   : "line_style"  Number
		 ;
x_offset         : "x_offset"  attributeOFF
	         ;
attributeOFF     : (T_HIFEN)? Number
            | nboolean
	         ;
module       : "module"  STRI
		 ;
language  : "language"  STRI
		 ;
nestedClasses   : "nestedClasses"  nestedClasses_list
	     	 ;
nestedClasses_list : T_LPAR "list"  "nestedClasses" (class_Object_nested)* T_RPAR
		   ;
class_Object_nested : T_LPAR "object" "Class"
                      token:STRI
                      { mr.startClass(token.getText()); }
                      classAttributes
                      { mr.endClass(); }
                      T_RPAR
		    ;
nabstract returns [ boolean ret ] { ret = false; }
          : "abstract"
            ret = nboolean
          ;
nboolean returns [ boolean ret ] { ret = false; }
         : "FALSE" | "TRUE" { ret = true; }
         | T_DOT( ( "F" T_DOT )
                | ( "T" T_DOT { ret = true; })
                | ( "Y" T_DOT { ret = true; })
                | ( "N" T_DOT ) )
         ; 

class MDLLexer extends Lexer;
options {
  charVocabulary = '\0'..'\377';
  k=4;
  testLiterals=false;
  caseSensitive=false;
}
{
   private mvcase.dialogs.ProgressDialog pd;

   public MDLLexer(InputStream in, mvcase.dialogs.ProgressDialog p_pd)
   {
      this(in);
      pd = p_pd;
   }

   public void newline()
   {
      super.newline();
      if((getLine()) % 50 == 0)
         pd.setValue(getLine());
   }
}

T_LPAR      : '(' ;
T_RPAR      : ')' ;
T_DOT       : '.' ;
T_COMMA     : ',' ;
T_ARROBA    : '@' ;
T_HIFEN     : '-' ;

Number : ('0'..'9')+
         ('.' ('0'..'9')+)?
         (('e')('+'|'-')?('0'..'9')+)?
         ('f')?
         ('u'|'l')?
       ;  
ID  options {testLiterals=true;}
       :   ('a'..'z'|'_')('a'..'z'|'_'|'0'..'9')*
       ;  
STRI options {testLiterals=false;}
       :   '"'! ((~'"')|( '\\' ~'\n'))* '"'!
       ;
STRI2 options {testLiterals=false;}
       :   '|'! ( ~('\r'|'\n') )*  '\r''\n' { newline(); }
       ;

IGNORE
       : ( ' ' { $setType(Token.SKIP); }
         | '\t' { $setType(Token.SKIP); }
         | '\f' { $setType(Token.SKIP); }
         | '\r' { $setType(Token.SKIP); }
         | '\n' { newline(); $setType(Token.SKIP); }
         ) 
       | "/*" ('\0'..'\377')* "*/"  { $setType(Token.SKIP); }
       ;
